CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

GetFitPoint Method (ActiveX)

2023-1-4 08:22| 发布者: admin| 查看: 624| 评论: 0|来自: AutoCAD

摘要: 获取样条曲线在给定索引处的拟合点。

获取样条曲线在给定索引处的拟合点。

支持的平台:仅窗口

签名

工 务 局:

RetVal = object.GetFitPoint(Index)
对象

类型:样条

此方法适用的对象。

指数

访问:仅输入

类型:

拟合点列表中查询拟合点的位置。索引必须是以 0 开头的正整数。

返回值(RetVal)

类型:变体(双精度的三元素数组)

给定索引位置处拟合点的 3D WCS 坐标。

言论

没有额外的评论。

例子

工 务 局:

Sub Example_GetFitPoint()
    ' This example creates a spline object in model space.
    ' It then finds the coordinates of the fit points.

    ' Create the spline
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    ZoomAll
    
    ' Display the coordinates of the fit points
    Dim fitPoint As Variant
    Dim index As Integer
    For index = 0 To splineObj.NumberOfFitPoints - 1
        fitPoint = splineObj.GetFitPoint(index)
        MsgBox "Fit point " & index + 1 & " is at " & fitPoint(0) & ", " & fitPoint(1) & ", " & fitPoint(2), , "GetFitPoint Example"
    Next
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_GetFitPoint()
    ;; This example creates a spline object in model space.
    ;; It then finds the coordinates of the fit points.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))

    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 0)
          endTan (vlax-3d-point 0.5 0.5 0)
          fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(1 1 0
                                     5 5 0
                                     10 0 0
                                    )
    )
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))
    (vla-ZoomAll acadObj)
    
    ;; Display the coordinates of the fit points
    (setq index 0)
    (while (>= (1- (vla-get-NumberOfFitPoints splineObj)) 0)
        (setq fitPoint (vlax-safearray->list (vlax-variant-value (vla-GetFitPoint splineObj index))))
        (alert (strcat "Fit point " (itoa (1+ index)) " is at " (rtos (nth 0 fitPoint) 2) ", " (rtos (nth 1 fitPoint) 2) ", " (rtos (nth 2 fitPoint) 2)))
        (setq index (1+ index))
    )
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-19 12:24

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部